---
title: Migrating from Firebug
slug: Tools/Migrating_from_Firebug
tags:
  - Firebug
  - Migration
---
<div>{{ToolsSidebar}}</div>

<p class="summary">When migrating from Firebug to the Firefox Developer Tools, you may wonder where the features you loved in Firebug are available in the Developer Tools. The following list aims to help Firebug users to find their way into the Developer Tools.</p>

<hr>
<div class="column-container">
<div class="column-third"> </div>

<div class="column-third">
<p><img alt="" src="https://mdn.mozillademos.org/files/15588/logo-developer-quantum.png" style="display: block; margin: 0px auto;"></p>

<p style="text-align: center;">For the latest developer tools and features, try Firefox Developer Edition.</p>

<p><a href="https://www.mozilla.org/en-US/firefox/developer/" style="width: 280px; display: block; margin-left: auto; margin-right: auto; padding: 10px; text-align: center; border-radius: 4px; background-color: #81BC2E; white-space: nowrap; color: white; text-shadow: 0px 1px 0px rgba(0, 0, 0, 0.25); box-shadow: 0px 1px 0px 0px rgba(0, 0, 0, 0.2), 0px -1px 0px 0px rgba(0, 0, 0, 0.3) inset;">Download Firefox Developer Edition</a></p>
</div>

<div class="column-third"> </div>
</div>

<hr>
<h2 id="General">General</h2>

<h3 id="Activation">Activation</h3>

<p>Firebug's activation is URL based respecting the <a href="https://en.wikipedia.org/wiki/Same_origin_policy">same origin policy</a>. That means that when you open a page on the same origin in a different tab, Firebug gets opened automatically. And when you open a page of a different origin in the same tab, it closes automatically. The DevTools' activation on the other hand is tab based. That means, that when you open the DevTools in a tab, they stay open even when you switch between different websites. When you switch to another tab, though, they're closed.</p>

<h3 id="Open_the_tools">Open the tools</h3>

<p>Firebug can be opened by pressing F12. To open it to inspect an element it is possible to press <kbd>Ctrl</kbd>+<kbd>Shift</kbd>+<kbd>C</kbd> / <kbd>Cmd</kbd>+<kbd>Opt</kbd>+<kbd>C</kbd>. The DevTools share the same shortcuts, but also provide <a href="/en-US/docs/Tools/Keyboard_shortcuts#Opening_and_closing_tools">shortcuts for the different panels</a>. E.g. the <a href="/en-US/docs/Tools/Network_Monitor">Network Monitor</a> can be opened via <kbd>Ctrl</kbd>+<kbd>Shift</kbd>+<kbd>Q</kbd> / <kbd>Cmd</kbd>+<kbd>Opt</kbd>+<kbd>Q</kbd>, the <a href="/en-US/docs/Tools/Web_Console">Web Console</a> via <kbd>Ctrl</kbd>+<kbd>Shift</kbd>+<kbd>K</kbd> / <kbd>Cmd</kbd>+<kbd>Opt</kbd>+<kbd>K</kbd> and the Debugger via <kbd>Ctrl</kbd>+<kbd>Shift</kbd>+<kbd>S</kbd> / <kbd>Cmd</kbd>+<kbd>Opt</kbd>+<kbd>S</kbd>.</p>

<h2 id="Web_Console">Web Console</h2>

<p>The <a href="/en-US/docs/Tools/Web_Console">Web Console</a> is the equivalent of Firebug's Console panel. It shows log information associated with a web page and allows you to execute JavaScript expressions via its <a href="/en-US/docs/Tools/Web_Console/The_command_line_interpreter">command line</a>. The display between both is somewhat different. This may be changed in {{bug(1269730)}}.</p>

<h3 id="Filter_log_messages">Filter log messages</h3>

<p>Firebug offers two ways to filter log messages, via the options menu and via the filter buttons within the toolbar. The Developer Tools console offers similar functionality via the <a href="/en-US/docs/Tools/Web_Console/Console_messages#Filtering_by_category">filter buttons inside its toolbar</a> — centralized at one place.</p>

<h3 id="Command_Line_API">Command Line API</h3>

<p>The Command Line API in Firebug provides some special functions for your convenience. The Developer Tools command line has <a href="/en-US/docs/Tools/Web_Console/The_command_line_interpreter#Helper_commands">some functions in common</a>, but also has some other functions and misses others.</p>

<h3 id="Console_API">Console API</h3>

<p>To log things to the console from within the web page Firebug makes a Console API available within the page. The Developer Tools share the <a href="/en-US/docs/Web/API/console">same API</a>, so your <code>console.*</code> statements will continue to work.</p>

<h3 id="Persist_logs">Persist logs</h3>

<p>In Firebug you can click the <em>Persist</em> button within the toolbar to keep the logged messages between page navigations and reloads. In the DevTools this option is called <em><a href="/en-US/docs/Tools/Settings#Common_preferences">Enable persistent logs</a></em> and is available within the Toolbox Options panel.</p>

<h3 id="Server_logs">Server logs</h3>

<p>Firebug extensions like FirePHP allow to log server-side messages to the Firebug console. This functionality is already <a href="/en-US/docs/Tools/Web_Console/Console_messages#Server">integrated into the DevTools</a> using the <a href="https://craig.is/writing/chrome-logger">ChromeLogger</a> protocol and doesn't require any extensions to be installed.</p>

<h3 id="Command_history">Command history</h3>

<p>The command history available through a button in Firebug's command line, is available by pressing <a href="/en-US/docs/Tools/Web_Console/The_command_line_interpreter#Command_history"><kbd>↑</kbd>/<kbd>↓</kbd> within the DevTools command line</a>.</p>

<h3 id="Inspect_object_properties">Inspect object properties</h3>

<p>By clicking on an object logged within the console you can inspect the object's properties and methods within the DOM panel. In the Firefox DevTools you can also inspect the objects. The difference is that they <a href="/en-US/docs/Tools/Web_Console/Rich_output#Examining_object_properties">show the properties and methods within a side panel inside the Web Console</a>.</p>

<h3 id="Show_network_requests">Show network requests</h3>

<p>The Console panel in Firebug allows to log {{Glossary("AJAX")}} requests (aka {{Glossary("XMLHttpRequest", "XMLHttpRequests")}}). This option is also available within the DevTools Web Console via the <em>Net</em> &gt; <em>XHR</em>. Furthermore, the Web Console even allows to display all other network requests via <em>Net</em> &gt; <em>Log</em>.</p>

<h3 id="View_JSON_and_XML_structures">View JSON and XML structures</h3>

<p>To view JSON and XML responses of {{Glossary("AJAX")}} requests, Firebug has special tabs when expanding the request within the Console panel. The DevTools Web Console shows those structures directly under the "Response" tab.</p>

<h3 id="Multi-line_command_line">Multi-line command line</h3>

<p>Firebug's console has a multi-line command line called Command Editor. The DevTools do not have a side panel like the Command Editor (which is requested in {{bug(1133849)}}), but therefore has a separate tool called <a href="/en-US/docs/Tools/Scratchpad">Scratchpad</a>, which can be <a href="/en-US/docs/Tools/Settings#Default_Firefox_Developer_Tools">added as panel to the toolbox</a> or opened in a separate window via Firefox menu &gt; <em>Developer</em> &gt; <em>Scratchpad</em> or <kbd>Shift</kbd> + <kbd>F4</kbd>. Also, the normal command line smartly enters a line break when it recognizes an unfinished command like <code>document.</code> and you hit <kbd>Enter</kbd>. You can also manually enter a line break by pressing <kbd>Shift</kbd> + <kbd>Enter</kbd>.</p>

<h3 id="Response_preview">Response preview</h3>

<p>There is a <em>Preview</em> tab when a network request logged to the console is expanded in Firebug. The Web Console displays a preview within the <em>Response</em> tab. It is currently missing the preview for HTML, XML and SVG, though, which is tracked in {{bug(1247392)}} and {{bug(1262796)}}, but when you click on the URL of the request you switch to the <a href="/en-US/docs/Tools/Network_Monitor">Network Monitor</a>, which has a <em>Preview</em> tab.</p>

<h2 id="Inspector">Inspector</h2>

<p>Firebug has an HTML panel, which allows to edit HTML/XML/SVG and the CSS related to it. Within the DevTools this functionality is served by the <a href="/en-US/docs/Tools/Page_Inspector">Page Inspector</a>.</p>

<h3 id="Edit_HTML">Edit HTML</h3>

<p>Within the Page Inspector the tag attributes and the contents can be edited inline just like in Firebug. Beyond that it allows to edit the tag names inline.</p>

<p>You can also edit the HTML directly. In Firebug you do this by right-clicking a node and clicking Edit HTML... in the context menu. In the DevTools this option is also available via the context menu. There the option is called <a href="/en-US/docs/Tools/Page_Inspector/How_to/Examine_and_edit_HTML#Editing_HTML_2">Edit As HTML</a>. Only the live preview of changes is currently missing, which is tracked in {{bug(1067318)}} and {{bug(815464)}}.</p>

<h3 id="Copy_HTML_and_related_information">Copy HTML and related information</h3>

<p>Firebug's HTML panel allows to copy the inner and outer HTML of an element as well as the CSS and XPath to it via the context menu of an element. The Page Inspector provides the same functionality except copying XPaths. This is covered by {{bug(987877)}}.</p>

<h3 id="Edit_CSS">Edit CSS</h3>

<p>Both tools allow to view and edit the CSS rules related to the element selected within the node view in a similar way. Firebug has a Style side panel for this, the DevTools have a <a href="/en-US/docs/Tools/Page_Inspector/How_to/Examine_and_edit_CSS">Rules side panel</a>.</p>

<p>In Firebug you add new rules by right-clicking and choosing <em>Add Rule...</em> from the context menu. The DevTools also have a context menu option for that named <a href="/en-US/docs/Tools/Page_Inspector/How_to/Examine_and_edit_CSS#Add_rules"><em>Add New Rule</em> and additionally have a + button</a> within the Rules panel's toolbar to create new rules.</p>

<p>To edit element styles, i.e. the CSS properties of the {{htmlattrxref("style")}} attribute of an element, in Firebug you have to right-click into the Style side panel and choose Edit Element Style... from the context menu. The DevTools display an <a href="/en-US/docs/Tools/Page_Inspector/How_to/Examine_and_edit_CSS#element_rule">element {} rule</a> for this purpose, which requires a single click into it to start editing the properties.</p>

<h3 id="Auto-completion_of_CSS">Auto-completion of CSS</h3>

<p>As in Firebug, the Rules view provides an auto-completion for the CSS property names and their values. A few property values are not auto-completed yet, which is tracked in {{bug(1337918)}}.</p>

<h3 id="Copy_paste_CSS">Copy &amp; paste CSS</h3>

<p>Firebug's Style side panel as well as the DevTools' Rules side panel provide options within their context menus to copy the CSS rule or the style declarations. The DevTools additionally provide an option to copy the selector of a rule and copy disabled property declarations as commented out. They are missing the option to copy the whole style declaration, though this can be achieved by selecting them within the panel and copying the selection by pressing <kbd>Ctrl</kbd>+<kbd>C</kbd> or via the context menu.</p>

<p>The Rules side panel of the DevTools is smarter when it comes to pasting CSS into it. You can paste whole style declarations into an existing rule property declarations which are commented out are automatically disabled.</p>

<h3 id="Toggle_pseudo-classes">Toggle pseudo-classes</h3>

<p>Firebug lets you toggle the CSS <a href="/en-US/docs/Web/CSS/Pseudo-classes">pseudo-classes</a> {{cssxref(":hover")}}, {{cssxref(":active")}} and {{cssxref(":focus")}} for an element via the options menu of the Style side panel. In the DevTools there are two ways to do the same. The first one is to toggle them via the <a href="/en-US/docs/Tools/Page_Inspector/How_to/Examine_and_edit_CSS#Setting_hover_active_focus">pseudo-class panel within the Rules side panel</a>. The second one is to right-click and element within the node view and toggle the pseudo-classes via the <a href="/en-US/docs/Tools/Page_Inspector/How_to/Examine_and_edit_HTML#Context_menu_reference">context menu</a>.</p>

<h3 id="Examine_CSS_shorthand_properties">Examine CSS shorthand properties</h3>

<p>CSS <a href="/en-US/docs/Web/CSS/Shorthand_properties">shorthand properties</a> can be split into their related longhand properties by setting the option <em>Expand Shorthand Properties</em> within the Style side panel. The DevTools' Rules panel is a bit smarter and allows you to expand individual shorthand properties by clicking the twisty besides them.</p>

<h3 id="Only_show_applied_styles">Only show applied styles</h3>

<p>The Style side panel in Firebug has an option to display only the properties of a CSS rule that are applied to the selected element and hide all overwritten styles. There is no such feature in the <a href="/en-US/docs/Tools/Page_Inspector/How_to/Examine_and_edit_CSS">Rules side panel</a> of the DevTools, but it is requested in {{bug(1335327)}}.</p>

<h3 id="Inspect_box_model">Inspect box model</h3>

<p>In Firebug the <a href="/en-US/docs/Learn/CSS/Introduction_to_CSS/Box_model">box model</a> can be inspected via the Layout side panel. In the DevTools the <a href="/en-US/docs/Tools/Page_Inspector/How_to/Examine_and_edit_the_box_model">box model is part of the Computed side panel</a>. Both tools highlight the different parts of the box model within the page when hovering them in the box model view. Also, both tools allow you to edit the different values inline via a click on them.</p>

<h3 id="Inspect_computed_styles">Inspect computed styles</h3>

<p>The computed values of CSS properties are displayed within the DevTools' <a href="/en-US/docs/Tools/Page_Inspector/How_to/Examine_and_edit_CSS#Examine_computed_CSS">Computed side panel</a> like within Firebug's Computed side panel. The difference is that in the DevTools the properties are always listed alphabetically and not grouped (see {{bug(977128)}}) and there is no option to hide the Mozilla specific styles, therefore there is an input field allowing to filter the properties.</p>

<h3 id="Inspect_events">Inspect events</h3>

<p>Events assigned to an element are displayed in the Events side panel in Firebug. In the DevTools they are shown when clicking the small 'ev' icon besides an element within the node view. Both tools allow to display wrapped event listeners (e.g. listeners wrapped in jQuery functions). To improve the UI of the DevTools, there is also a request to add an Events side panel to them like the one in Firebug (see {{bug(1226640)}}).</p>

<h3 id="Stop_script_execution_on_DOM_mutation">Stop script execution on DOM mutation</h3>

<p>In Firebug you can break on DOM mutations, that means that when an element is changed, the script execution is stopped at the related line within the JavaScript file, which caused the change. This feature can globally be enabled via the <em>Break On Mutate</em> button, or individually for each element and for different types of changes like attribute changes, content changes or element removal. Unfortunately, the DevTools do not have this feature yet (see {{bug(1004678)}}). To stop the script execution there, you need to set a breakpoint on the line with the modification within the <a href="/en-US/docs/Tools/Debugger">Debugger panel</a>.</p>

<h3 id="Search_for_elements_via_CSS_selectors_or_XPaths">Search for elements via CSS selectors or XPaths</h3>

<p>Firebug allows to search for elements within the HTML panel via CSS selectors or XPaths. Also the <a href="/en-US/docs/Tools/Page_Inspector/How_to/Examine_and_edit_HTML#Searching">DevTools' Inspector panel allows to search for CSS selectors</a>. It even displays a list with matching IDs or classes. Searching by XPaths is not supported though (see {{bug(963933)}}.</p>

<h2 id="Debugger">Debugger</h2>

<p>What's the Script panel in Firebug, is the <a href="/en-US/docs/Tools/Debugger">Debugger panel</a> in the DevTools. Both allow you to debug JavaScript code executed on a website.</p>

<h3 id="Switch_between_sources">Switch between sources</h3>

<p>Firebug has a Script Location Menu listing all JavaScript sources related to the website. Those sources can be static, i.e. files, or they can be dynamically generated (i.e. scripts executed via event handlers, <code>eval()</code>, <code>new Function()</code>, etc.). In the DevTools' Debugger panel the scripts are listed at the left side within the <a href="/en-US/docs/Tools/Debugger/UI_Tour#Source_list_pane">Sources side panel</a>. Dynamically generated scripts are only listed there when they are <a href="/en-US/docs/Tools/Debugger/How_to/Debug_eval_sources">named via a <code>//# sourceURL</code> comment</a>.</p>

<h3 id="Managing_breakpoints">Managing breakpoints</h3>

<p>In Firebug you can set different types of breakpoints, which are all listed within the Breakpoints side panel. In the DevTools the breakpoints are shown below each script source within the <a href="/en-US/docs/Tools/Debugger/UI_Tour#Source_list_pane">Sources side panel</a>. Those panels allow you to enable and disable single or all breakpoints and to remove single breakpoints or all of them at once. They do currently only allow to set script breakpoints. XHR, DOM, Cookie and Error breakpoints are not supported yet (see {{bug(821610)}}, {{bug(1004678)}}, {{bug(895893)}} and {{bug(1165010)}}). While there are no breakpoints for single JavaScript errors, there is a setting <em>Pause on Exceptions</em> within the <a href="/en-US/docs/Tools/Debugger/Settings">Debugger panel options</a>.</p>

<h3 id="Step_through_code">Step through code</h3>

<p>Once the script execution is stopped, you can step through the code using the Continue (<kbd>F8</kbd>), Step Over (<kbd>F10</kbd>), Step Into (<kbd>F11</kbd>) and Step Out (<kbd>Shift</kbd>+<kbd>F11</kbd>) options. They work the same in both tools.</p>

<h3 id="Examine_call_stack">Examine call stack</h3>

<p>When the script execution is paused, Firebug displays the function call stack within its Stack side panel. In there the functions are listed together with their call parameters. In the DevTools the function call stack is shown within the <a href="/en-US/docs/Tools/Debugger/UI_Tour#Call_stack_pane">Call Stack side panel</a>. To see the call parameters in the DevTools, you need to have a look at the <a href="/en-US/docs/Tools/Debugger/How_to/Examine,_modify,_and_watch_variables#Examine_variables">Variables side panel</a>.</p>

<h3 id="Examine_variables">Examine variables</h3>

<p>The Watch side panel in Firebug displays the {{domxref("window")}} object (the global scope) by default. With the script execution halted it shows the different variable scopes available within the current call stack frame. Furthermore, it allows you to add and manipulate watch expressions. The DevTools have a <a href="/en-US/docs/Tools/Debugger/How_to/Examine,_modify,_and_watch_variables">Variables side panel</a>, which works basically the same. The main difference is that it is empty when the script execution is not stopped, i.e. it doesn't display the <code>window</code> object. Though you can inspect that object either via the <a href="/en-US/docs/Tools/DOM_Property_Viewer">DOM property viewer</a> or via the <a href="/en-US/docs/Tools/Web_Console">Web Console</a>.</p>

<h2 id="Style_Editor">Style Editor</h2>

<p>The <a href="/en-US/docs/Tools/Style_Editor">Style Editor</a> in the Firefox DevTools allows you to examine and edit the different CSS style sheets of a page like Firebug's CSS panel does it. In addition to that it allows to create new style sheets and to import existing style sheets and apply them to the page. It also allows you to toggle individual style sheets.</p>

<h3 id="Switch_between_sources_2">Switch between sources</h3>

<p>The CSS panel of Firebug allows to switch between different CSS sources using the CSS Location Menu. The Style Editor has a <a href="/en-US/docs/Tools/Style_Editor#The_style_sheet_pane">sidebar</a> for this purpose.</p>

<h3 id="Edit_a_style_sheet">Edit a style sheet</h3>

<p>Firebug's CSS panel offers three different ways for editing style sheets. The default one is to edit them inline like within the Style side panel. Furthermore it has a <a href="https://getfirebug.com/wiki/index.php/CSS_Panel#Edit_Button">Source and a Live Edit mode</a>, which allow to edit the selected style sheet like within a text editor. The Style Editor of the DevTools only has one way to edit style sheets, which corresponds to Firebug's Live Edit mode.</p>

<h3 id="Try_out_CSS_selectors">Try out CSS selectors</h3>

<p>Firebug's Selectors side panel provides a way to validate a CSS selector. It lists all elements matching the entered selector. The DevTools don't have this feature yet, but it's requested in {{bug(1323746)}}.</p>

<h3 id="Searching_within_the_style_sheets">Searching within the style sheets</h3>

<p>Firebug allows to search within the style sheets via the search field. The Style Editor in the DevTools also provides a way to search within a style sheet, though there is currently no option to search within multiple sheets (see {{bug(889571)}}) and also not via a regular expression (see {{bug(1362030)}}.</p>

<h2 id="Performance_Tool">Performance Tool</h2>

<p>Firebug allows to profile JavaScript performance via the "Profile" button within the Console panel or the <code>console.profile()</code> and <code>console.profileEnd()</code> commands. The DevTools provide advanced tooling regarding performance profiling. A profile can be created via <code><a href="/en-US/docs/Web/API/Console/profile">console.profile()</a></code> and <code><a href="/en-US/docs/Web/API/Console/profileEnd">console.profileEnd()</a></code> like in Firebug or via the "Start Recording Performance" button in the <a href="/en-US/docs/Tools/Performance">Performance Tool</a>. The output of the <a href="/en-US/docs/Tools/Performance/Call_Tree">Call Tree</a> is the one that comes nearest to the output in Firebug, but the Performance panel provides much more information than just the JavaScript performance. E.g. it also provides information about HTML parsing or layout.</p>

<p>This is the part where Firebug and the DevTools differ the most, because the outputs are completely different. While Firebug focuses on JavaScript performance and provides detailed information about JavaScript function calls during the profiling session, the Performance Tool in the DevTools offers a broad spectrum of information regarding a website's performance but doesn't go into detail regarding JavaScript function calls.</p>

<h3 id="View_JavaScript_call_performance">View JavaScript call performance</h3>

<p>What comes nearest to Firebug's profiler output is the <a href="/en-US/docs/Tools/Performance/Call_Tree">Call Tree view</a> in the Performance panel. Like in Firebug it lists the total execution time of each function call under <em>Total Time</em> as well as the number of calls under <em>Samples</em>, the time spent within the function under <em>Self Time</em> and the related percentages in reference to the total execution time.</p>

<div class="note">
<p><strong>Note:</strong> The times and percentages listed in the DevTools' Call Tree view is not equivalent to the ones shown in Firebug, because it uses different APIs sampling the execution of the JavaScript code.</p>
</div>

<h3 id="Jump_to_function_declaration">Jump to function declaration</h3>

<p>Like in Firebug's profiler output the <a href="/en-US/docs/Tools/Performance/Call_Tree">Call Tree view</a> of the DevTools' Performance Tool allows to jump to the line of code where the called JavaScript function is defined. In Firebug the source link to the function is located at the right side of the Console panel output while within the DevTools the link is placed on the right side within the Call Tree View.</p>

<h2 id="Network_Monitor">Network Monitor</h2>

<p>To monitor network requests Firebug provides a Net panel. The Firefox DevTools allow to inspect the network traffic using the <a href="/en-US/docs/Tools/Network_Monitor">Network Monitor</a>. Both tools provide similar information including a timeline showing the request and response times of the network requests.</p>

<h3 id="Inspect_request_information">Inspect request information</h3>

<p>Both Firebug and the Firefox DevTools' Network Monitor allow you to inspect the information about a request by clicking on it. The only difference is that Firebug shows the information below the request while the Network Monitor displays it within a side panel.</p>

<p>In both tools there are different tabs containing different kinds of information for the selected request. They contain a <em>Headers</em>, <em>Params</em>, <em>Response</em> and <em>Cookies</em> panel. A preview of the response is shown within specifically named panels like <em>HTML</em>. The Network Monitor has a <em>Preview</em> panel for this purpose. It doesn't provide information about the cached data yet (see {{bug(859051)}}), but provides a <em>Security</em> tab in addition to Firebug's information and a <em>Timings</em> tab showing detailed information about the network timings.</p>

<h3 id="View_request_timings">View request timings</h3>

<p>Firebug offers detailed information about the network timings related to a request by hovering the Timeline column within its Net panel. The Network Monitor shows this information within a <a href="/en-US/docs/Tools/Network_Monitor#Timings">Timings side panel</a> when you select a request.</p>

<h3 id="View_remote_address">View remote address</h3>

<p>The remote address of a request is shown within the Remote IP column within Firebug. In the Network Monitor the address is shown at <em>Remote Address</em> in the <em>Headers</em> tab when a request is selected.</p>

<h3 id="Search_within_requests">Search within requests</h3>

<p>The search field within Firebug allows to search within the requests. The search field in the Firefox DevTools filters the requests by the entered string.</p>

<p>Firebug allowed to search within the response body of the network requests by checking <em>Response Bodies</em> within its search field options. This feature is not available yet within the Network Monitor, but it's requested in {{bug(1334408)}}. While response bodies can't be searched yet, the Network Monitor allows to <a href="/en-US/docs/Tools/Network_Monitor#Filtering_by_properties">filter by different request properties</a>.</p>

<h2 id="Storage_Inspector">Storage Inspector</h2>

<p>The Cookies panel in Firebug displays information related to the cookies created by a page and allows to manipulate the information they store. Within the DevTools this functionality is located within the <a href="/en-US/docs/Tools/Storage_Inspector">Storage Inspector</a>. In contrast to Firebug the Storage Inspector not only allows to inspect cookies but also other kinds of storages like the local and session storage, the cache and <a href="/en-US/docs/Web/API/IndexedDB_API">IndexedDB</a> databases.</p>

<h3 id="Inspect_cookies">Inspect cookies</h3>

<p>All cookies related to a website are listed inside the Cookies panel in Firebug. Inside the DevTools, the cookies are grouped by domain under the Cookies section within the <a href="/en-US/docs/Tools/Storage_Inspector">Storage Inspector</a>. Both show pretty much the same information per cookie, i.e. the name, value, domain, path, expiration date and whether the cookie is HTTP-only.</p>

<p>The DevTools don't show by default whether a cookie is secure, but this can be enabled by right-clicking the table header and checking <em>Secure</em> from the context menu. Additionally, the DevTools allow to display the creation date of a cookie as well as when it was last accessed and whether it is host-only.</p>

<h3 id="Edit_cookies">Edit cookies</h3>

<p>To edit a cookie in Firebug you have to right-click the cookie and choose <em>Edit</em> from the context menu. Then a dialog pops up allowing you to edit the data of the cookie and save it. Inside the Storage Inspector you just have to double-click the data you want to edit. Then an inline editor allows you to edit the value.</p>

<h3 id="Delete_cookies">Delete cookies</h3>

<p>Firebug's Cookies panel allows you to delete all cookies of a website via the menu option <em>Cookies</em> &gt; <em>Remove Cookies</em> or by pressing <kbd>Ctrl</kbd>+<kbd>Shift</kbd>+<kbd>O</kbd>. It also allows you to only remove session cookies via <em>Cookies</em> &gt; <em>Remove Session Cookies</em> and to remove single cookies by right-clicking them and choosing <em>Delete</em>. The DevTools Storage Inspector allows to remove all cookies and a single one by right-clicking on a cookie and choosing <em>Delete All</em> resp. <em>Delete "&lt;cookie name&gt;"</em>. Additionally, it allows to delete all cookies from a specific domain via the context menu option <em>Delete All From "&lt;domain name&gt;"</em>. It currently does not allow to only delete session cookies (see {{bug(1336934)}}).</p>

<h2 id="Developer_Toolbar">Developer Toolbar</h2>

<h3 id="Display_of_error_count">Display of error count</h3>

<p>When there are JavaScript errors on a page, the Firebug Start Button shows a badge with their number. The DevTools show the number of errors in the <a href="/en-US/docs/Tools/GCLI">Developer Toolbar</a>.</p>

<h3 id="Command_API">Command API</h3>

<p>Firebug offers a great variety of commands, which can be executed within its command line. The Developer Toolbar also provides an <a href="/en-US/docs/Tools/GCLI#Commands">API with a lot of different commands</a> to control the DevTools and execute different tasks.</p>

<h2 id="Feedback">Feedback</h2>

<p>We are always happy to respond to feedback and questions. If you have any queries or points of view, feel free to share them on our <a href="https://discourse.mozilla.org/c/devtools">DevTools Discourse Forum</a>.</p>
